﻿//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//Quick_Interpret_Palette.jsx    by Fred CRETET
//replace  the interpret footage window 
//fcretet aaat gmail dooot com
// please post  comment @ http://aenhancers.com if you use this script.
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
{
   var myPanel;

   function Quick_Interpret_palette(thisObj) {
     myPanel = (thisObj instanceof Panel) ? thisObj : new Window("palette", "Quick_Interpret_palette", [100, 100, 600, 300]);
     //Jeff Almasol's solution to fix text color
     var winGfx = myPanel.graphics;
     var darkColorBrush = winGfx.newPen(winGfx.BrushType.SOLID_COLOR, [0,0,0], 1);

	 myPanel.txt_fields = myPanel.add("statictext", [10, 10, 250, 25], "|     Fields     |     Ratio     |     Alpha     |     Loop     |");
	
	 myPanel.butUpper = myPanel.add("button", [20, 30, 65, 50], "Upper");	
     myPanel.butLower = myPanel.add("button", [20, 55, 65, 75], "Lower");	
     myPanel.butOff = myPanel.add("button", [20, 80, 65, 100], "Off");

      myPanel.butSquare = myPanel.add("button", [80, 30, 125, 50], "Square");
	 myPanel.but1_46 = myPanel.add("button", [80, 55, 125, 75], "1,46");
	 myPanel.but1_09 = myPanel.add("button", [80, 80, 125, 100], "1,09");
	
	 myPanel.butIgnore = myPanel.add("button", [135, 30, 195, 50], "Ignore");
	 myPanel.butStraight = myPanel.add("button", [135, 55, 195, 75], "Straight");
	 myPanel.butPremult_Black = myPanel.add("button", [135, 80, 195, 100], "Premult Bk");
	 myPanel.butPremult_white = myPanel.add("button", [135, 105, 195, 125], "Premult Wt");
	 myPanel.butInvert = myPanel.add("button", [135, 130, 195, 150], "Invert");
	 
	 myPanel.butLoop1 = myPanel.add("button", [200, 30, 245, 50], "1");
	 myPanel.butLoop10 = myPanel.add("button", [200, 55, 245, 75], "10");
	 myPanel.butLoop100 = myPanel.add("button", [200, 80, 245, 100], "100");
	 
	 myPanel.txt_infos = myPanel.add("statictext", [08, 160, 250, 180], "Interpret selected Footage");

	 myPanel.butUpper.onClick = Upper;
	 myPanel.butLower.onClick = Lower;
	 myPanel.butOff.onClick = Off;
	 
	 myPanel.butSquare.onClick = Square;
     myPanel.but1_46.onClick = Aspect_1_46;
	 myPanel.but1_09.onClick = Aspect_1_09;
	 
	 myPanel.butStraight.onClick = Straight;
	 myPanel.butPremult_Black.onClick = Premult_black;
	 myPanel.butPremult_white.onClick = Premult_white;
	 myPanel.butIgnore.onClick = IgnoreAlpha;
	 myPanel.butInvert.onClick = InvertAlpha;
	 
	 myPanel.butLoop10.onClick = Loop_10;
	 myPanel.butLoop1.onClick = Loop_1;
	 myPanel.butLoop100.onClick = Loop_100;
      return myPanel;
   }


////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	function Upper(){
		for(idx=1 ; idx <=  app.project.numItems ; idx++)
		{
			if(app.project.item(idx).selected==true)
			{
				if(app.project.item(idx).file != null ){
					if(app.project.item(idx).frameRate==0)
					{
						alert(" No fields in still frame for AE...");
					}
					else
					{
							app.project.item(idx).mainSource.fieldSeparationType = FieldSeparationType.UPPER_FIELD_FIRST;
							app.project.item(idx).mainSource.highQualityFieldSeparation =1;
					}
				}
			}
		
		}
	}
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	function Lower(){
		for(idx=1 ; idx <=  app.project.numItems ; idx++)
		{
			if(app.project.item(idx).selected==true)
			{
				if(app.project.item(idx).file != null ){
					if(app.project.item(idx).frameRate==0)
					{
						alert(" No fields in still frame for AE...");
					}
					else
					{
							app.project.item(idx).mainSource.fieldSeparationType = FieldSeparationType.LOWER_FIELD_FIRST;
							app.project.item(idx).mainSource.highQualityFieldSeparation =1;
					}
				}
			}
		
		}
	}
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	function Off(){
		for(idx=1 ; idx <=  app.project.numItems ; idx++)
		{
			if(app.project.item(idx).selected==true)
			{
				if(app.project.item(idx).file != null ){
					if(app.project.item(idx).frameRate==0)
					{
						alert(" No fields in still frame for AE...");
					}
					else
					{
							app.project.item(idx).mainSource.fieldSeparationType = FieldSeparationType.OFF;
					}
				}
			}
		
		}
	}
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	function Square(){
		for(idx=1 ; idx <=  app.project.numItems ; idx++)
		{
			if(app.project.item(idx).selected==true)
			{
				if(app.project.item(idx).file != null ){
						app.project.item(idx).pixelAspect ="1";
					}
			}
		
		}
	}
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	function Aspect_1_46(){
		for(idx=1 ; idx <=  app.project.numItems ; idx++)
		{
			if(app.project.item(idx).selected==true)
			{
				if(app.project.item(idx).file != null ){
						app.project.item(idx).pixelAspect ="1.46";
					}
			}
		
		}
	}
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	function Aspect_1_09(){
		for(idx=1 ; idx <=  app.project.numItems ; idx++)
		{
			if(app.project.item(idx).selected==true)
			{
				if(app.project.item(idx).file != null ){
						app.project.item(idx).pixelAspect ="1.09";
					}
			}
		
		}
	}
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	function Straight(){
		for(idx=1 ; idx <=  app.project.numItems ; idx++)
		{
			if(app.project.item(idx).selected==true)
			{
				if(app.project.item(idx).file != null ){
						app.project.item(idx).mainSource.alphaMode =AlphaMode.STRAIGHT;
					}
			}
		
		}
	}
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	function Premult_black(){
		for(idx=1 ; idx <=  app.project.numItems ; idx++)
		{
			if(app.project.item(idx).selected==true)
			{
				if(app.project.item(idx).file != null ){
						app.project.item(idx).mainSource.alphaMode =AlphaMode.PREMULTIPLIED;
						app.project.item(idx).mainSource.premulColor =[0,0,0];
						
					}
			}
		
		}
	}
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	function Premult_white(){
		for(idx=1 ; idx <=  app.project.numItems ; idx++)
		{
			if(app.project.item(idx).selected==true)
			{
				if(app.project.item(idx).file != null ){
						app.project.item(idx).mainSource.alphaMode =AlphaMode.PREMULTIPLIED;
						app.project.item(idx).mainSource.premulColor =[1,1,1];
						
					}
			}
		
		}
	}
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	function IgnoreAlpha(){
		for(idx=1 ; idx <=  app.project.numItems ; idx++)
		{
			if(app.project.item(idx).selected==true)
			{
				if(app.project.item(idx).file != null ){
						app.project.item(idx).mainSource.alphaMode =AlphaMode.IGNORE;
					}
			}
		
		}
	}
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	function InvertAlpha(){
		for(idx=1 ; idx <=  app.project.numItems ; idx++)
		{
			if(app.project.item(idx).selected==true)
			{
				if(app.project.item(idx).file != null ){
					//alert( app.project.item(idx).mainSource.invertAlpha);
					if( app.project.item(idx).mainSource.invertAlpha == false)
						{
							app.project.item(idx).mainSource.invertAlpha = true;
						}
					else
						{
							app.project.item(idx).mainSource.invertAlpha = false;
						}
					}
			}
		
		}
	}

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	function Loop_10(){
		for(idx=1 ; idx <=  app.project.numItems ; idx++)
		{
			if(app.project.item(idx).selected==true)
			{
				if(app.project.item(idx).file != null ){
					if(app.project.item(idx).frameRate==0)
					{
						alert(" No loop in still frame...");
					}
					else
					{
							app.project.item(idx).mainSource.loop=10;
					}
				}
			}
		
		}
	}
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	function Loop_1(){
		for(idx=1 ; idx <=  app.project.numItems ; idx++)
		{
			if(app.project.item(idx).selected==true)
			{
				if(app.project.item(idx).file != null ){
					if(app.project.item(idx).frameRate==0)
					{
						alert(" No loop in still frame...");
					}
					else
					{
							app.project.item(idx).mainSource.loop=1;
					}
				}
			}
		
		}
	}
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	function Loop_100(){
		for(idx=1 ; idx <=  app.project.numItems ; idx++)
		{
			if(app.project.item(idx).selected==true)
			{
				if(app.project.item(idx).file != null ){
					if(app.project.item(idx).frameRate==0)
					{
						alert(" No loop in still frame...");
					}
					else
					{
							app.project.item(idx).mainSource.loop=100;
					}
				}
			}
		
		}
	}
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
 Quick_Interpret_palette(this); 
}










